"
stx:goodies/smallsense - A productivity plugin for Smalltalk/X IDE
Copyright (C) 2013-2014 Jan Vrany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
"
"{ Package: 'stx:goodies/smallsense' }"

"{ NameSpace: SmallSense }"

EditSupportTests subclass:#SmalltalkEditSupportTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SmallSense-Tests'
!

!SmalltalkEditSupportTests class methodsFor:'documentation'!

copyright
"
stx:goodies/smallsense - A productivity plugin for Smalltalk/X IDE
Copyright (C) 2013-2014 Jan Vrany

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
"
! !

!SmalltalkEditSupportTests methodsFor:'accessing-classes'!

editSupportClass
    "superclass SmallSense::EditSupportTests says that I am responsible to implement this method"

    ^ SmalltalkEditSupport

    "Created: / 23-07-2014 / 07:16:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmalltalkEditSupportTests methodsFor:'tests - indent-on-paste'!

test_indent_on_paste_01a

    codeView contents:'test
    Debug ifTrue:[ 

    ].
    self halt.'.

    codeView selectFromLine: 5 col: 5 toLine: 5 col: 14.

    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '        self halt.'.

    "Created: / 23-07-2014 / 09:46:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_indent_on_paste_01b

    codeView contents:'test
    Debug ifTrue:[ 

    ].
    self halt.'.

    codeView selectFromLine:5 col:1 toLine:6 col:0.

    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '        self halt.'.

    "Created: / 23-07-2014 / 09:47:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_indent_on_paste_02a

    codeView contents:'test
    Debug ifTrue:[ 

    ].
    param isNil ifTrue:[
        self halt.
    ]'.

    codeView selectFromLine: 5 col: 5 toLine: 7 col: 5.

    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '        param isNil ifTrue:['.
    self assert: (codeView list at: 4) = '            self halt.'.
    self assert: (codeView list at: 5) = '        ]'.

    "Created: / 23-07-2014 / 10:20:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_indent_on_paste_02b

    codeView contents:'test
    Debug ifTrue:[ 

    ].
    param isNil ifTrue:[
        self halt.
    ]'.

    codeView selectFromLine: 5 col: 1 toLine: 8 col: 0.

    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '        param isNil ifTrue:['.
    self assert: (codeView list at: 4) = '            self halt.'.
    self assert: (codeView list at: 5) = '        ]'.

    "Created: / 23-07-2014 / 10:20:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_indent_on_paste_03a

    codeView contents:'test
    Debug ifTrue:[ 

    ].
    param isNil ifTrue:[
        self halt.
    ]'.

    codeView selectFromLine: 5 col: 5 toLine: 6 col: 18.

    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '        param isNil ifTrue:['.
    self assert: (codeView list at: 4) = '            self halt.'.

    "Created: / 23-07-2014 / 23:28:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_indent_on_paste_03b

    codeView contents:'test
    Debug ifTrue:[ 

    ].
    param isNil ifTrue:[
        self halt.
    ]'.

    codeView selectFromLine: 5 col: 1 toLine: 7 col: 0.


    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '        param isNil ifTrue:['.
    self assert: (codeView list at: 4) = '            self halt.'.

    "Created: / 23-07-2014 / 23:28:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_indent_on_paste_04a

    codeView contents:'test
    Debug ifTrue:[ 
        Transcript showCR:''XXX''.
    ].
    self halt.'.

    codeView selectFromLine: 5 col: 5 toLine: 5 col: 14.

    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '    self halt.    Transcript showCR:''XXX''.'.

    "Created: / 24-07-2014 / 10:18:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_indent_on_paste_04b

    codeView contents:'test
    Debug ifTrue:[ 
        Transcript showCR:''XXX''.
    ].
    self halt.'.

    codeView selectFromLine: 5 col: 5 toLine: 6 col: 0.

    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '    self halt.'.
    self assert: (codeView list at: 4) = '    Transcript showCR:''XXX''.'.

    "Created: / 24-07-2014 / 10:21:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_indent_on_paste_04c

    codeView contents:'test
    Debug ifTrue:[ 
        Transcript showCR:''XXX''.
    ].
    self halt.'.

    codeView selectFromLine: 5 col: 5 toLine: 6 col: 0.

    codeViewInteractor type: #Cut.
    codeViewInteractor type: #(CursorUp CursorUp CursorRight CursorRight CursorRight CursorRight).
    codeViewInteractor type: #Paste.

    self assert: (codeView list at: 3) = '        self halt.'.
    self assert: (codeView list at: 4) = 'Transcript showCR:''XXX''.'.

    "Created: / 24-07-2014 / 10:22:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

